shivammathur/setup-php

GitHub action to setup PHP with required extensions, php.ini configuration, code-coverage support and various tools like composer

Setup PHP in GitHub Actions

Setup PHP in GitHub Actions

GitHub Actions status Codecov Code Coverage LICENSE PHP Versions Supported

Setup PHP with required extensions, php.ini configuration, code-coverage support and various tools like composer in GitHub Actions. This action gives you a cross platform interface to setup the PHP environment you need to test your application. Refer to Usage section and examples to see how to use this.

Contents

:tada: PHP Support

|PHP Version|Stability|Release Support| |--- |--- |--- | |5.6|Stable|End of life| |7.0|Stable|End of life| |7.1|Stable|End of life| |7.2|Stable|Security fixes only| |7.3|Stable|Active| |7.4|Stable|Active| |8.0|Experimental|In development|

Note: Specifying 8.0 in php-version input installs a nightly build of PHP 8.0.0-dev with PHP JIT, Union Types v2 and other new features. See experimental setup for more information.

:cloud: OS/Platform Support

|Virtual environment|matrix.operating-system| |--- |--- | |Windows Server 2019|windows-latest or windows-2019| |Ubuntu 18.04|ubuntu-latest or ubuntu-18.04| |Ubuntu 16.04|ubuntu-16.04| |macOS X Catalina 10.15|macOS-latest or macOS-10.15|

:heavy_plus_sign: PHP Extension Support

  • On ubuntu by default extensions which are available as a package can be installed. If the extension is not available as a package but it is on PECL, it can be installed by specifying pecl in the tools input.
  • On windows extensions which have windows binary on PECL can be installed.
  • On macOS extensions which are on PECL can be installed.
  • Extensions which are installed along with PHP if specified are enabled.
  • Extensions which cannot be installed gracefully leave an error message in the logs, the action is not interrupted.

:wrench: Tools Support

These tools can be setup globally using the tools input.

codeception, composer, composer-prefetcher, deployer, pecl, phinx, phpcbf, phpcpd, php-config, php-cs-fixer, phpcs, phpize, phpmd, phpstan, phpunit, prestissimo, psalm

uses: shivammathur/[email protected]
with:
  php-version: '7.4'
  tools: php-cs-fixer, phpunit

To setup a particular version of a tool, specify it in the form tool:version.
Version should be in semver format and a valid release of the tool.

uses: shivammathur/[email protected]
with:
  php-version: '7.4'
  tools: php-cs-fixer:2.15.5, phpunit:8.5.1

Note - composer is setup by default. - Specifying version for composer and pecl has no effect, latest version of both tools will be setup. - If the version specified for the tool is not in semver format, latest version of the tool will be setup. - Tools which cannot be installed gracefully leave an error message in the logs, the action is not interrupted.

:signal_strength: Coverage support

Xdebug

Specify coverage: xdebug to use Xdebug.
Runs on all PHP versions supported except 8.0.

uses: shivammathur/[email protected]
with:
  php-version: '7.4'
  coverage: xdebug

PCOV

Specify coverage: pcov to use PCOV.
It is much faster than Xdebug.
PCOV needs PHP >= 7.1.
If your source code directory is other than src, lib or, app, specify pcov.directory using the ini-values input.

uses: shivammathur/[email protected]
with:
  php-version: '7.4'
  ini-values: pcov.directory=api #optional, see above for usage.
  coverage: pcov

Disable coverage

Specify coverage: none to disable both Xdebug and PCOV.
Consider disabling the coverage using this PHP action for these reasons.

  • You are not generating coverage reports while testing.
  • It will remove Xdebug, which will have a positive impact on PHP performance.
  • You are using phpdbg for running your tests.
uses: shivammathur/[email protected]
with:
  php-version: '7.4'
  coverage: none

:memo: Usage

Inputs supported by this GitHub Action.

  • php-version required
  • extensions optional
  • ini-values optional
  • coverage optional
  • tools optional

See action.yml and usage below for more info.

Basic Setup

Setup a particular PHP version.

steps:
- name: Checkout
  uses: actions/[email protected]

- name: Setup PHP
  uses: shivammathur/[email protected]
  with:
    php-version: '7.4'
    extensions: mbstring, intl #optional, setup extensions
    ini-values: post_max_size=256M, short_open_tag=On #optional, setup php.ini configuration
    coverage: xdebug #optional, setup coverage driver
    tools: php-cs-fixer, phpunit #optional, setup tools globally

Matrix Setup

Setup multiple PHP versions on multiple operating systems.

jobs:
  run:
    runs-on: ${{ matrix.operating-system }}
    strategy:
      matrix:
        operating-system: [ubuntu-latest, windows-latest, macOS-latest]
        php-versions: ['5.6', '7.0', '7.1', '7.2', '7.3', '7.4']
    name: PHP ${{ matrix.php-versions }} Test on ${{ matrix.operating-system }}
    steps:
    - name: Checkout
      uses: actions/[email protected]

    - name: Setup PHP
      uses: shivammathur/[email protected]
      with:
        php-version: ${{ matrix.php-versions }}
        extensions: mbstring, intl #optional, setup extensions
        ini-values: post_max_size=256M, short_open_tag=On #optional, setup php.ini configuration
        coverage: xdebug #optional, setup coverage driver
        tools: php-cs-fixer, phpunit #optional, setup tools globally

Experimental Setup

Setup a nightly build of PHP 8.0.0-dev from the master branch of PHP.

  • This version is currently in development and is an experimental feature on this action.
  • PECL is installed by default with this version on ubuntu.
  • Some extensions might not support this version currently.
  • Refer to this RFC for configuring PHP JIT on this version.
  • Refer to this list of RFCs implemented in this version.
steps:
- name: Checkout
  uses: actions/[email protected]

- name: Setup PHP
  uses: shivammathur/[email protected]
  with:
    php-version: '8.0'
    extensions: mbstring #optional, setup extensions
    ini-values: opcache.jit_buffer_size=256M, opcache.jit=1235, pcre.jit=1 #optional, setup php.ini configuration
    coverage: pcov #optional, setup PCOV, Xdebug does not support this version yet.
    tools: php-cs-fixer, phpunit #optional, setup tools globally    

Cache dependencies

You can persist composer's internal cache directory using the action/cache GitHub Action. Dependencies cached are loaded directly instead of downloading them while installation. The files cached are available across check-runs and will reduce the workflow execution time.

Note: Please do not cache vendor directory using action/cache as that will have side-effects.

- name: Get Composer Cache Directory
  id: composer-cache
  run: echo "::set-output name=dir::$(composer config cache-files-dir)"

- name: Cache dependencies
  uses: actions/[email protected]
  with:
    path: ${{ steps.composer-cache.outputs.dir }}
    key: ${{ runner.os }}-composer-${{ hashFiles('**/composer.lock') }}
    restore-keys: ${{ runner.os }}-composer-

- name: Install Dependencies
  run: composer install --prefer-dist

In the above example, if you support a range of composer dependencies and do not commit composer.lock, you can use the hash of composer.json as the key for your cache.

key: ${{ runner.os }}-composer-${{ hashFiles('**/composer.json') }} 

Problem Matchers

You can setup problem matchers for your PHPUnit output. This will scan the errors in your tests and surface that information prominently in the GitHub Actions UI by creating annotations and log file decorations.

- name: Setup Problem Matchers for PHPUnit
  run: echo "::add-matcher::${{ runner.tool_cache }}/phpunit.json"

Examples

Examples for setting up this GitHub Action with different PHP Frameworks/Packages.

|Framework/Package|Runs on|Workflow| |--- |--- |--- | |CakePHP with MySQL and Redis|ubuntu|cakephp-mysql.yml| |CakePHP with PostgreSQL and Redis|ubuntu|cakephp-postgres.yml| |CakePHP without services|macOS, ubuntu and windows|cakephp.yml| |CodeIgniter|macOS, ubuntu and windows|codeigniter.yml| |Laravel with MySQL and Redis|ubuntu|laravel-mysql.yml| |Laravel with PostgreSQL and Redis|ubuntu|laravel-postgres.yml| |Laravel without services|macOS, ubuntu and windows|laravel.yml| |Lumen with MySQL and Redis|ubuntu|lumen-mysql.yml| |Lumen with PostgreSQL and Redis|ubuntu|lumen-postgres.yml| |Lumen without services|macOS, ubuntu and windows|lumen.yml| |Phalcon with MySQL|ubuntu|phalcon-mysql.yml| |Phalcon with PostgreSQL|ubuntu|phalcon-postgres.yml| |Roots/bedrock|ubuntu|bedrock.yml| |Roots/sage|ubuntu|sage.yml| |Slim Framework|macOS, ubuntu and windows|slim-framework.yml| |Symfony with MySQL|ubuntu|symfony-mysql.yml| |Symfony with PostgreSQL|ubuntu|symfony-postgres.yml| |Symfony without services|macOS, ubuntu and windows|symfony.yml| |Yii2 Starter Kit with MySQL|ubuntu|yii2-mysql.yml| |Yii2 Starter Kit with PostgreSQL|ubuntu|yii2-postgres.yml| |Zend Framework|macOS, ubuntu and windows|zend-framework.yml|

:scroll: License

The scripts and documentation in this project are released under the MIT License. This project has multiple dependencies and uses various works. Their licenses can be found in their respective repositories.

:+1: Contributions

Contributions are welcome! See Contributor's Guide. If you face any issues while using this or want to suggest a feature/improvement, create an issue here.

:sparkling_heart: Support this project

If this action helped you.

  • Please star the project and share it, this helps reach more people.
  • If you blog, write about your experience using this.
  • Support this project on Patreon or using Paypal.
  • If you need any help using this, reach out here Contact me on Codementor

:bookmark: This action uses the following works

:bookmark_tabs: Further Reading

Repo Not Found